Index: apps/app_milliwatt.c
===================================================================
--- apps/app_milliwatt.c	(revision 359655)
+++ apps/app_milliwatt.c	(revision 359656)
@@ -78,7 +78,7 @@
 static int milliwatt_generate(struct ast_channel *chan, void *data, int len, int samples)
 {
 	unsigned char buf[AST_FRIENDLY_OFFSET + 640];
-	const int maxsamples = ARRAY_LEN(buf);
+	const int maxsamples = ARRAY_LEN(buf) - (AST_FRIENDLY_OFFSET / sizeof(buf[0]));
 	int i, *indexp = (int *) data;
 	struct ast_frame wf = {
 		.frametype = AST_FRAME_VOICE,

Property changes on: .
___________________________________________________________________
Modified: branch-1.6.2-merged
   - /branches/1.6.2:1-279056,279207,279501,279561,279597,279609,279657,279784,279849,279946,280089,280160,280193,280229,280231,280306,280345,280449,280551,280671,280739,280983,281051,281391,281430,281567,281574,281722,281763,281873,281912,282130,282235,282467,282469,282576,282607,282730,282859,282890,282894,283049,283124,283318,283381,283558,283594,283691,283881,284002,284280,284317,284399,284472,284593-284595,284631,284665,284704,284778,284897,284958,285089,285196,285267,285366,285526,285529,285532,285563,285567,285639,285710,285744,285818,285930,285961,286024,286116-286117,286268,286456,286527,286557,286587,286681,286757,286998,287115,287119,287308,287387,287470,287558,287642,287685,287759,287934,288006,288113,288147,288193,288267,288340,288344,288417,288500,288637,288712,288747,289095,289178,289334,289339,289425,289553,289700,289704,289798,289874,289950,290101,290201,290254,290375,290396,290575,290712,290751,290863,291073,291110-291111,291229,291264,291280,291393,291580,291655,291904,291939,292049,292224,292229,292412,292556,292786,292867,293118,293158,293195-293196,293340,293417,293647,293723,293806,293969,294242,294277,294312,294429,294500,294639,294733,294822,294904,294910,294988,295062,295281,295440,295672,295710,295843,295868,295907,296001,296083,296166,296221,296466,296533,296671,296869,296950,296991,297073,297229,297311,297405,297534,297605,297713,297819,297824,297908,297960,298050,298194,298393,298477,298481,298597,298684,298817,298957,298962,299087,299130,299136,299242,299448,299530,299625,299864,300165,300298,300429,300431,300520,300574,300622,300951,301046,301089,301176,301220,301307,301310,301503,301594,301682,301730,301842,301848,302173,302265,302313,302416,302461,302504,302548,302551,302554,302599,302675,302693,302788,302833,302917,302920,303008,303106,303285,303548,303677,303769,303858,303960,304006,304096,304149,304181,304244,304250,304338,304461,304465,304659-304682,304726,304729,304773,304776,304865,304978,305082,305889,305985,306123,306126,306346,306618,306673,306865,306961,306966,306973,307227,307535,307792,307836,308007,308414,308678,308722,308814,308990,309033-309034,309083,309255,313278,313432,313435,313579,313859,314202,314205,314549,314620,314776,314778,314958,315052,315212,315258,315393,315502,315643,315672,315893,316093,316329,316475,316616,316644,316708,317255,317575,318230,318331,318548,319144,319202,319528,319653,320236,320271,320444,320562,323579,323733,324634,324643,325277,345800,347530,348515
   + /branches/1.6.2:1-279056,279207,279501,279561,279597,279609,279657,279784,279849,279946,280089,280160,280193,280229,280231,280306,280345,280449,280551,280671,280739,280983,281051,281391,281430,281567,281574,281722,281763,281873,281912,282130,282235,282467,282469,282576,282607,282730,282859,282890,282894,283049,283124,283318,283381,283558,283594,283691,283881,284002,284280,284317,284399,284472,284593-284595,284631,284665,284704,284778,284897,284958,285089,285196,285267,285366,285526,285529,285532,285563,285567,285639,285710,285744,285818,285930,285961,286024,286116-286117,286268,286456,286527,286557,286587,286681,286757,286998,287115,287119,287308,287387,287470,287558,287642,287685,287759,287934,288006,288113,288147,288193,288267,288340,288344,288417,288500,288637,288712,288747,289095,289178,289334,289339,289425,289553,289700,289704,289798,289874,289950,290101,290201,290254,290375,290396,290575,290712,290751,290863,291073,291110-291111,291229,291264,291280,291393,291580,291655,291904,291939,292049,292224,292229,292412,292556,292786,292867,293118,293158,293195-293196,293340,293417,293647,293723,293806,293969,294242,294277,294312,294429,294500,294639,294733,294822,294904,294910,294988,295062,295281,295440,295672,295710,295843,295868,295907,296001,296083,296166,296221,296466,296533,296671,296869,296950,296991,297073,297229,297311,297405,297534,297605,297713,297819,297824,297908,297960,298050,298194,298393,298477,298481,298597,298684,298817,298957,298962,299087,299130,299136,299242,299448,299530,299625,299864,300165,300298,300429,300431,300520,300574,300622,300951,301046,301089,301176,301220,301307,301310,301503,301594,301682,301730,301842,301848,302173,302265,302313,302416,302461,302504,302548,302551,302554,302599,302675,302693,302788,302833,302917,302920,303008,303106,303285,303548,303677,303769,303858,303960,304006,304096,304149,304181,304244,304250,304338,304461,304465,304659-304682,304726,304729,304773,304776,304865,304978,305082,305889,305985,306123,306126,306346,306618,306673,306865,306961,306966,306973,307227,307535,307792,307836,308007,308414,308678,308722,308814,308990,309033-309034,309083,309255,313278,313432,313435,313579,313859,314202,314205,314549,314620,314776,314778,314958,315052,315212,315258,315393,315502,315643,315672,315893,316093,316329,316475,316616,316644,316708,317255,317575,318230,318331,318548,319144,319202,319528,319653,320236,320271,320444,320562,323579,323733,324634,324643,325277,345800,347530,348515,359645